<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Poppins:wght@400;600&display=swap" rel="stylesheet">
    <link href='https://unpkg.com/boxicons@2.0.7/css/boxicons.min.css' rel='stylesheet'>

    <title>Document</title>
    <style>
        body {
            font-family: 'Poppins', sans-serif;
        }

        h2 {
            text-align: center;
            color: rgb(240, 240, 240);
        }

        form {

            width: 400px;
            padding: 1px 20px 20px;
            margin: auto;
            background-color: rgb(165, 165, 165);
            box-shadow: 2px 5px 5px rgba(0, 0, 0, 0.3);
            border-radius: 5px;
        }

        label {
            display: block;
            margin: 10px auto;
            font-weight: 00;

        }

        input {
            border: 3px solid rgb(233, 47, 47);
            padding: 10px;
            border-radius: 5px;
            background-color: rgb(165, 165, 165);
            width: 350px;
        }

        textarea {
            border: 3px solid rgb(233, 47, 47);
            padding: 10px;
            border-radius: 5px;
            background-color: rgb(165, 165, 165);
        }

        form .btn-form {
            display: block;
            background-color: rgb(233, 47, 47);
            color: white;
            width: 370px;
            margin: 7px 0;
            padding: 8px;
            border-radius: 7px;
        }

        form .btn-form:hover {
            display: block;
            background-color: rgb(235, 103, 103);
            color: white;
            width: 370px;
            margin: 7px 0;
            padding: 8px;
            border-radius: 7px;
        }

        hr {
            width: 30%;
            margin: 20px auto;
            border: 5px solid rgba(245, 73, 73, 0.767);
            border-radius: 10px;
        }

        table {
            margin: 40px auto;
            text-align: center;
            background-color: rgb(216, 216, 216);
        }

        table .btn1 {
            background-color: rgb(53, 134, 241);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }

        table .btn1:hover {
            background-color: rgb(11, 90, 192);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }

        table .btn2 {
            background-color: rgb(255, 65, 65);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }

        table .btn2:hover {
            background-color: rgb(214, 18, 18);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }

        table .btn3 {
            background-color: rgb(27, 233, 88);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }

        table .btn3:hover {
            background-color: rgb(9, 179, 60);
            color: white;
            border: none;
            padding: 5px;
            border-radius: 5px;
            font-size: .9em;
        }
    </style>
</head>

<body>
    <div id="app1">
        <form action="" @submit.prevent="submitForm()">
            <h2>FORM INPUT DATA</h2>
            <p v-if="errors.length">
                <b>Please correct for following this error:</b>
            <ul>
                <li v-for="error in errors"> {{error}}</li>
            </ul>
            </p>
            <label for="">Title : </label>
            <input type="text" name="title" :disabled="buttonStatus == 'upload'" ref="title" v-model="title">
            <label for="">Description : </label>
            <textarea v-model="description" :disabled="buttonStatus == 'upload'" name=" description" ref="description"
                rows="5" cols="47"></textarea>
            <div v-if="buttonStatus == 'submit'">
                <button class="btn-form" type="submit">SUBMIT</button>
            </div>
            <div v-else-if="buttonStatus == 'edit'">
                <button class="btn-form" type="button" @click="updateData(idEditData)">UPDATE</button>
                <button class="btn-form" type="button" @click="cancelBtn()">CANCEL</button>
            </div>
            <div v-else-if="buttonStatus == 'upload'">
                <input type="file" name="photo" ref="photo">
                <button class="btn-form" type="button" @click="uploadData(idUploadData)">UPLOAD</button>
                <input class="btn-form" type="button" @click="cancelBtn()" value="CANCEL">
            </div>

        </form>
        <hr>

        <h2 style="color: teal;">Detail Data</h2>

        <table width="100%" border="1">
            <tr>
                <th width="5%">No</th>
                <th width="10%">Foto Profile</th>
                <th width="20%">Title</th>
                <th width="45%">Description</th>
                <th width="20%">Action</th>
            </tr>
            <tr v-for="(blog,index) in blogs">
                <td>{{index+1}}</td>
                <td><img width="100" :src="blog.photo ? photoDomain + blog.photo : 'https://dummyimage.com/16:9x1080'"
                        alt=""></td>
                <td>{{ blog.title}}</td>
                <td>{{ blog.description}}</td>
                <td style="padding: 4px;">
                    <button class="btn1" @click="updateBlog(blog)"><i class='bx bxs-edit'></i>Edit</button>
                    <button class="btn2" @click="removeBlog(blog.id)"><i class='bx bxs-trash'></i>Hapus</button>
                    <button class="btn3" @click="uploadPhoto(blog)"><i class='bx bx-upload'></i>Upload</button>
                </td>
            </tr>
        </table>

    </div>



    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>

    <script>
        var vm = new Vue({
            el: '#app1',
            data: {
                photoDomain: 'http://demo-api-vue.sanbercloud.com',
                title: '',
                description: '',
                errors: [],
                blogs: [],
                buttonStatus: 'submit',
                idEditData: null,
                idUploadData: null
            },
            methods: {
                validationForm: function () {
                    if (this.title.length < 5) {
                        this.errors.push('Title minimal 5 karakter')
                        this.$refs.title.focus()
                    }
                    if (this.description.length > 50) {
                        this.errors.push('Title max 50 karakter')
                        this.$refs.description.focus()

                    }
                },

                clearData: function () {
                    this.title = ''
                    this.description = ''
                    this.buttonStatus = 'submit'
                    this.idEditData = null
                    this.idUploadData = null
                },

                submitForm() {

                    this.validationForm()
                    if (this.errors.length === 0) {

                        let formData = new FormData()
                        formData.append('title', this.title)
                        formData.append('description', this.description)

                        const config = {
                            method: "post",
                            url: "http://demo-api-vue.sanbercloud.com/api/blog",
                            data: formData
                        }
                        axios(config)
                            .then((response) => {
                                this.clearData()
                                this.getBlogs()
                                alert(response.data.message)
                            })
                            .catch((error) => {

                            })

                    }
                },

                getBlogs: function () {
                    const config = {
                        method: "get",
                        url: "http://demo-api-vue.sanbercloud.com/api/blog"
                    }
                    axios(config)
                        .then((response) => {
                            this.blogs = response.data.blogs

                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },

                removeBlog: function (id) {
                    const config = {
                        method: "post",
                        url: `http://demo-api-vue.sanbercloud.com/api/blog/${id}`,
                        params: { _method: "DELETE" }
                    }

                    axios(config)
                        .then((response) => {
                            this.getBlogs()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },
                updateBlog: function (blog) {
                    this.title = blog.title
                    this.description = blog.description
                    this.buttonStatus = 'edit'
                    this.idEditData = blog.id
                },
                cancelBtn: function () {
                    this.title = ""
                    this.description = ""
                    this.buttonStatus = 'submit'
                },
                updateData: function (id) {
                    this.validationForm()

                    if (this.errors.length === 0) {
                        const data = new FormData()
                        data.append('title', this.title)
                        data.append('description', this.description)

                        const config = {
                            method: 'post',
                            url: `http://demo-api-vue.sanbercloud.com/api/blog/${id}`,
                            params: { _method: 'PUT' },
                            data: data
                        }

                        axios(config)
                            .then((response) => {
                                this.clearData()
                                this.getBlogs()
                                alert(response.data.message)
                            })
                            .catch((error) => {
                                console.log(error)
                            })
                    }

                },
                uploadPhoto: function (blog) {
                    this.title = blog.title
                    this.description = blog.description
                    this.buttonStatus = 'upload'
                    this.idUploadData = blog.id
                },
                uploadData: function (id) {
                    const file = this.$refs.photo.files[0]

                    const data = new FormData()
                    data.append('photo', file)
                    const config = {
                        method: 'post',
                        url: `http://demo-api-vue.sanbercloud.com/api/blog/${id}/upload-photo`,
                        data: data
                    }
                    axios(config)
                        .then((response) => {
                            this.clearData()
                            this.getBlogs()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                }
            },
            created() {
                this.getBlogs()
            },

        })
    </script>
</body>

</html>